#include <stdio.h>
#include <stdlib.h>

 int FactorialA(int k);
 int FactorialB(int k);
 void NotBreakStack(int n);
 void BreakStack(int n);

int main ()
{
    printf("test1: %d\n", FactorialA(5));
    printf("test2: %d\n", FactorialB(5));

    NotBreakStack(5000); //   
    BreakStack(5000); 
    
    printf("End test\n");
    return 0;
}

 int FactorialA(int k)
 {
   if (k==1) return 1;
   return k*FactorialA(k-1);
 }

 int FactorialB(int k)
 {
   int f = 1;
   while (k) { f *= k--; }
   return f;
 }

 void NotBreakStack(int n)
 {
     static int cnt = 0;
     static int *b = nullptr;
     int *a = (int*)malloc(1000000*sizeof(int));
     if (!a) printf("alloc error\n");

     if (n==0) return;
     printf("%5d  %p  %d\n", ++cnt, a, a - b);
     b = a;

     NotBreakStack(n - 1);
     free(a);
 } 

 void BreakStack(int n)
 {
     static int cnt = 0;
     static int *b = nullptr;
     int a[n];

     if (n==0) return;
     printf("%5d  %p  %d\n", ++cnt, a, a - b);

     BreakStack(n - 1);
 } 
